<?php
   /*
     * $Id: cache.php 897 2005-12-23 03:28:31Z dmorton $
     *
     * MAIA MAILGUARD LICENSE v.1.0
     *
     * Copyright 2004 by Robert LeBlanc <rjl@renaissoft.com>
     *                   David Morton   <mortonda@dgrmm.net>
     * All rights reserved.
     *
     * PREAMBLE
     *
     * This License is designed for users of Maia Mailguard
     * ("the Software") who wish to support the Maia Mailguard project by
     * leaving "Maia Mailguard" branding information in the HTML output
     * of the pages generated by the Software, and providing links back
     * to the Maia Mailguard home page.  Users who wish to remove this
     * branding information should contact the copyright owner to obtain
     * a Rebranding License.
     *
     * DEFINITION OF TERMS
     *
     * The "Software" refers to Maia Mailguard, including all of the
     * associated PHP, Perl, and SQL scripts, documentation files, graphic
     * icons and logo images.
     *
     * GRANT OF LICENSE
     *
     * Redistribution and use in source and binary forms, with or without
     * modification, are permitted provided that the following conditions
     * are met:
     *
     * 1. Redistributions of source code must retain the above copyright
     *    notice, this list of conditions and the following disclaimer.
     *
     * 2. Redistributions in binary form must reproduce the above copyright
     *    notice, this list of conditions and the following disclaimer in the
     *    documentation and/or other materials provided with the distribution.
     *
     * 3. The end-user documentation included with the redistribution, if
     *    any, must include the following acknowledgment:
     *
     *    "This product includes software developed by Robert LeBlanc
     *    <rjl@renaissoft.com>."
     *
     *    Alternately, this acknowledgment may appear in the software itself,
     *    if and wherever such third-party acknowledgments normally appear.
     *
     * 4. At least one of the following branding conventions must be used:
     *
     *    a. The Maia Mailguard logo appears in the page-top banner of
     *       all HTML output pages in an unmodified form, and links
     *       directly to the Maia Mailguard home page; or
     *
     *    b. The "Powered by Maia Mailguard" graphic appears in the HTML
     *       output of all gateway pages that lead to this software,
     *       linking directly to the Maia Mailguard home page; or
     *
     *    c. A separate Rebranding License is obtained from the copyright
     *       owner, exempting the Licensee from 4(a) and 4(b), subject to
     *       the additional conditions laid out in that license document.
     *
     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS
     * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
     * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
     * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
     * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
     * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
     * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
     * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
     * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
     * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
     * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     *
     */
class MessageCache {
    
    var $type;
    var $dbh;
    var $smarty;
    var $sortby;
    var $sort_order;
    var $select_stmt;
    
    function MessageCache($type, & $dbh, & $smarty) {
        $this->smarty =& $smarty;
        $this->dbh =& $dbh;
        $this->type = $type;
        $this->smarty->assign("cache_type", $type);
        $this->sortby= array();
    }
    
    function get_offset() {
        global $_GET;
        return isset($_GET["offset"]) ? $_GET["offset"] : 0;
    }
    
    function get_sort_field() {
        switch ($this->type) {
                case "ham": $field = "ham_cache_sort";
                    break;
                case "spam": $field = "spam_quarantine_sort";
                    break;
                case "virus": $field = "virus_quarantine_sort";
                    break;
                case "attachment": $field = "attachment_quarantine_sort";
                    break;
                case "header": $field = "header_quarantine_sort";
                    break;
                default: $field = "ham_cache_sort";
        }
        $this->sort_field = $field;
        return $field;
    
    }
    
    function get_sort_abbrev() {
        switch ($this->type) {
            case "ham": $field = "H";
                    break;
            case "spam": $field = "S";
                break;
            case "virus": $field = "V";
                break;
            case "attachment": $field = "F";
                break;
            case "header": $field = "B";
                break;
            default: $field = "H";
        }
        return $field;
    }
    
    function set_sort_order($sort, $euid, $sid) {
        global $_GET;
         $field = $this->get_sort_field();

         $sort = strtoupper(trim($_GET["sort"]));
         if (strlen($sort) == 2) {
             switch($sort[0]) {
                 case "X":
                 case "D":
                 case "F":
                 case "S":
                     if ($sort[1] == "A" || $sort[1] == "D") {
                         $update = "UPDATE maia_users SET ". $field ." = ? WHERE id = ?";
                         $this->dbh->query($update, array($sort, $euid));
                         header("Location: list-cache.php" . $sid. "?cache_type=". $this->type);
                         exit;
                     }
                     break;
                 default:
                     break;
             }
            
         }
    }
    
    function get_sort_order($euid) {
        global $dbh, $msid, $sid;
        $sort = strtoupper(get_user_value($euid, $this->get_sort_field()));
             switch($sort[0]) {
                 case "X":
                     $this->sortby['score'] = ($sort[1] == "A" ? "xd" : "xa"); //FIXME - depends on spam/ham/other
                     $this->sortby['column'] = "score";
                     $this->sortby['date'] = "da";
                     $this->sortby['from'] = "fa";
                     $this->sortby['subject'] = "sa";
                     break;
                 case "D":
                     $this->sortby['score'] = "xa"; //FIXME - depends on spam/ham/other
                     $this->sortby['column'] = "received_date";
                     $this->sortby['date'] = ($sort[1] == "A" ? "dd" : "da");
                     $this->sortby['from'] = "fa";
                     $this->sortby['subject'] = "sa";
                     break;
                 case "F":
                     $this->sortby['score'] = "xa"; //FIXME - depends on spam/ham/other
                     $this->sortby['column'] = "sender_email";
                     $this->sortby['date'] = "da";
                     $this->sortby['from'] = ($sort[1] == "A" ? "fd" : "fa");
                     $this->sortby['subject'] = "sa";
                     break;
                 case "S":
                     $this->sortby['score'] = "xa"; //FIXME - depends on spam/ham/other
                     $this->sortby['column'] = "subject";
                     $this->sortby['date'] = "da";
                     $this->sortby['from'] = "fa";
                     $this->sortby['subject'] = ($sort[1] == "A" ? "sd" : "sa");
                     break;
                 default:
                     $this->sortby['score'] = "xa"; //FIXME - depends on spam/ham/other
                     $this->sortby['column'] = "score";
                     $this->sortby['date'] = "da";
                     $this->sortby['from'] = "fa";
                     $this->sortby['subject'] = "sa";
             }
             if ($sort[1] == "D") {
                 $this->sort_order = "DESC";
             } else {
                 $this->sort_order = "ASC";
             }
             $this->smarty->assign("sortby", $this->sortby);
             $this->smarty->assign("sort_order", $this->sort_order);
    }
    
    function set_select() {
       $this->select_stmt = "SELECT maia_mail.id, maia_mail.received_date, maia_mail.score, " .
                     "maia_mail.sender_email, maia_mail.subject, maia_mail.envelope_to " .
              "FROM maia_mail, maia_mail_recipients " .
              "WHERE maia_mail.id = maia_mail_recipients.mail_id " .
              "AND maia_mail_recipients.type = '". $this->get_sort_abbrev() ."' " .
              "AND maia_mail_recipients.recipient_id = ? " .
              "ORDER BY maia_mail." . $this->sortby['column'] . " " . $this->sort_order;
    }
    
    function confirm_cache($euid) {    
    	$message = "";
    	$confirmed = 0;
    	$reported = 0;
		$deleted = 0;
		$rescued = 0;
        global $_POST, $lang;
        $items = $_POST['cache_item'];
        foreach ($items as $mail_id => $value) {
            	// report item
                if ($_POST['submit'] == "spam") {
                     switch ($this->type) {
                       case 'ham':
                          // Mark the item as Confirmed Spam
                          $update = "UPDATE maia_mail_recipients SET type = 'C' " .
                                    "WHERE recipient_id = ? AND mail_id = ?";
                          $this->dbh->query($update, array($euid, $mail_id));
                          record_mail_stats($euid, $mail_id, "fn");
                          $reported++;
                          break;
                       case 'spam':
                         confirm_spam($euid, $mail_id);
                         $confirmed++;
                       default:
                     }
                 //send item
                } elseif ($_POST['submit'] == "ham") {
                    switch ($this->type) {
                       case 'ham':
                          confirm_ham($euid, $mail_id);
                          $confirmed++;
                          break;
                       default:
                          $result = rescue_item($euid, $mail_id);
                          if (strncmp($result, "2", 1) == 0) {
                            $rescued++;
                          } else {
	                        $message .= $result . "\n";                    
                          }                      
                    }
                       
                       
                    //delete item.
                } elseif ($_POST['submit'] == "delete") {

                    delete_mail_reference($euid, $mail_id);
                    $deleted++;

                }
        }
       
        //$sth->free(); */
        update_mail_stats($euid, "suspected_ham");
        if ($confirmed > 0) {
            $message .= sprintf($lang['text_ham_confirmed'], $confirmed) . ".<br>";
        }

        if ($reported > 0) {
            $message .= sprintf($lang['text_spam_reported'], $reported) . ".<br>";
        }
        if ($deleted > 0) {
            $message .= sprintf($lang['text_ham_deleted'], $deleted) . ".<br>";
        }
        $this->smarty->assign("message", $message);
    
    }
    
    function render($euid) {
        global $lang, $msid, $html_charset, $offset;
        $magic_quotes = get_magic_quotes_gpc();
        $nothing_to_show = true;
        
        $this->smarty->assign("msid", $msid);
        $this->smarty->assign("lang", $lang);

           $sth = $this->dbh->query($this->select_stmt, array($euid));
           if ($sth->numRows() > 0)
           {
              $select2 = "SELECT email FROM users WHERE maia_user_id = ?";
              $sth2 = $this->dbh->query($select2, array($euid));
              while ($row2 = $sth2->fetchrow()) {
                  $personal_addresses[] = $row2["email"];
              }
              $sth2->free();
              $personal_addresses = array_flip($personal_addresses);
              $domain_default = is_a_domain_default_user($euid);
              $per_page = get_user_value($euid, "items_per_page");
              $pager = new DB_Pager($sth, $offset, $per_page);
              $data = $pager->build();
              $maxid = 0;
              $nothing_to_show = false;
        
              $this->smarty->assign("data", $data);
              $this->smarty->assign("offset", $offset);
        
        
            if ($sth->numrows() == 1) {
                $item_text = $lang['text_item'];
            } else {
                $item_text = $lang['text_items'];
            }

            $count = 0;
            $rows = array();
        
              while ($row = $pager->fetchrow())
              {
                if ($row["id"] > $maxid) {
                      $maxid = $row["id"];
                }
                $file = "";
                $select = "SELECT file_name, file_type " .
                      "FROM maia_banned_attachments_found " .
                      "WHERE mail_id = ?";
                $sth2 = $this->dbh->query($select, array($row["id"]));
                while ($row2 = $sth2->fetchrow()) {
                    $file .= $row2["file_name"] . " (" . $row2["file_type"] . ")<br>";
                }
                $sth2->free();
                $rows[$count]['id'] = $row['id'];
                $rows[$count]['file'] = $file;
                $rows[$count]['received_date'] = $row["received_date"];
                $rows[$count]['sender_email'] = $magic_quotes ? stripslashes($row["sender_email"]) : $row["sender_email"];
                $rows[$count]['score'] = $row['score'];
 
                    $to_list = explode(" ", $row["envelope_to"]);
                    $rectmp = "";
                    foreach ($to_list as $recipient) {
                        if (isset($personal_addresses[$recipient]) || $domain_default) {
                          $rectmp[] = $recipient;
                        }
                    }
                    $rows[$count]['recipient_email'] = $rectmp;

           $subject = trim(htmlentities($magic_quotes ? stripslashes($row['subject']) : $row['subject']));
           if ($subject == "") {
              $subject = "(" . $lang['text_no_subject'] . ")";
           }else{
                 $subject = decode_header($subject, $html_charset);
           }	    
                  $rows[$count]['subject'] = $subject;
                  $count++;
          }
          $sth->free();
              $this->smarty->assign("row", $rows); 
              $this->smarty->assign("maxid", $maxid);
        }
        $this->smarty->assign("nothing_to_show", $nothing_to_show);   
        $this->smarty->display("list-cache.tpl");
    }
    
}
?>
