<?php
    /*
     * $Id: settings.php 954 2006-02-13 01:37:50Z dmorton $
     *
     * MAIA MAILGUARD LICENSE v.1.0
     *
     * Copyright 2004 by Robert LeBlanc <rjl@renaissoft.com>
     *                   David Morton   <mortonda@dgrmm.net>
     * All rights reserved.
     *
     * PREAMBLE
     *
     * This License is designed for users of Maia Mailguard
     * ("the Software") who wish to support the Maia Mailguard project by
     * leaving "Maia Mailguard" branding information in the HTML output
     * of the pages generated by the Software, and providing links back
     * to the Maia Mailguard home page.  Users who wish to remove this
     * branding information should contact the copyright owner to obtain
     * a Rebranding License.
     *
     * DEFINITION OF TERMS
     *
     * The "Software" refers to Maia Mailguard, including all of the
     * associated PHP, Perl, and SQL scripts, documentation files, graphic
     * icons and logo images.
     *
     * GRANT OF LICENSE
     *
     * Redistribution and use in source and binary forms, with or without
     * modification, are permitted provided that the following conditions
     * are met:
     *
     * 1. Redistributions of source code must retain the above copyright
     *    notice, this list of conditions and the following disclaimer.
     *
     * 2. Redistributions in binary form must reproduce the above copyright
     *    notice, this list of conditions and the following disclaimer in the
     *    documentation and/or other materials provided with the distribution.
     *
     * 3. The end-user documentation included with the redistribution, if
     *    any, must include the following acknowledgment:
     *
     *    "This product includes software developed by Robert LeBlanc
     *    <rjl@renaissoft.com>."
     *
     *    Alternately, this acknowledgment may appear in the software itself,
     *    if and wherever such third-party acknowledgments normally appear.
     *
     * 4. At least one of the following branding conventions must be used:
     *
     *    a. The Maia Mailguard logo appears in the page-top banner of
     *       all HTML output pages in an unmodified form, and links
     *       directly to the Maia Mailguard home page; or
     *
     *    b. The "Powered by Maia Mailguard" graphic appears in the HTML
     *       output of all gateway pages that lead to this software,
     *       linking directly to the Maia Mailguard home page; or
     *
     *    c. A separate Rebranding License is obtained from the copyright
     *       owner, exempting the Licensee from 4(a) and 4(b), subject to
     *       the additional conditions laid out in that license document.
     *
     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS
     * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
     * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
     * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
     * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
     * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
     * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
     * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
     * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
     * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
     * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     *
     */

    /*
     * NOTE FOR USERS OF MAIA 0.9.x: Configuration settings have been moved
     * to config.php.  This settings.php file is equivalent to what used to
     * be the spam-virus.php file.
     */

    require_once ("core.php");
    require_once ("authcheck.php");
	require_once ("auth.php");
    require_once ("display.php");
    require_once ("maia_db.php");
    $display_language = get_display_language($euid);
    $html_charset = get_html_charset($euid);
    require_once ("./locale/$display_language/display.php");
    require_once ("./locale/$display_language/db.php");
    require_once ("./locale/$display_language/settings.php");


    
    //inserted stuff from xsettings.php
    // Find out which button we pressed to get here
    if (isset($_POST["submit"])) {
        $button = trim($_POST["submit"]);
        $button = stripslashes($button);
    } else {
        $button = "";
    }

    $message = ""; //initialize variable
	
    // get some system config items
    $select = "SELECT enable_charts, reminder_threshold_count, " .
                     "enable_spamtraps, enable_username_changes, " .
                     "enable_address_linking " .
              "FROM maia_config WHERE id = 0";
    $sth = $dbh->query($select);
    if ($row = $sth->fetchrow()) {
        $enable_charts = ($row["enable_charts"] == 'Y');
        $reminder_threshold_count = $row["reminder_threshold_count"];
        $enable_spamtraps = ($row["enable_spamtraps"] == 'Y');
        $enable_username_changes = ($row["enable_username_changes"] == 'Y');
        $enable_address_linking = ($row["enable_address_linking"] == 'Y');
    }
    $sth->free();
    
    // Pressed the "Update This Address' Settings" button or the
    // "Update ALL Addresses' Settings" button
    if ($button == $lang['button_update_address'] ||
        $button == $lang['button_update_all_addresses']) {

        if (isset($_POST["policy"])) { // actually, I think we prefer not to use this, in favor of what's in the 
            $policy_id = trim($_POST["policy"]); // users.policy_id
        } else {
            header("Location: logout.php");
            exit;
        }
        
        if (isset($_POST["user_id"])) {
            $maia_user_id = trim($_POST["user_id"]);
        } else {
            header("Location: logout.php");
            exit;
        }
  
        $select = "SELECT policy.id as policy_id, users.email, users.id as user_id from users LEFT JOIN policy ON users.policy_id = policy.id
                   WHERE users.maia_user_id = ? AND policy.id = ?";
        $sth = $dbh->query($select, array($maia_user_id, $policy_id));
  	    if ($sth->numRows() == 0 ) {
  	       header("Location: logout.php");
           exit;
  	    }
    	    
  	    $row = $sth->fetchRow();
    	     	  
   	    if (! (is_admin_for_domain($uid, 
   	                               get_domain_id("@" . get_domain_from_email($row["email"])))
   	           || is_superadmin($uid)
   	           || $maia_user_id == $euid 
   	        )) {
    	      header("Location: logout.php");
            exit;
        }
                                       
        $policy_id = $row['policy_id'];
        
        $sth->free();
      	$select = "SELECT virus_lover, " .
    	                 "spam_lover, " .
    	                 "banned_files_lover, " .
    	                 "bad_header_lover, " .
    	                 "bypass_virus_checks, " .
    	                 "bypass_spam_checks, " .
    	                 "bypass_banned_checks, " .
    	                 "bypass_header_checks, " .
                         "discard_viruses, " .
  	                 "discard_spam, " .
  	                 "discard_banned_files, " .
  	                 "discard_bad_headers, " .
    	                 "spam_modifies_subj, " .
    	                 "spam_tag_level, " .
    	                 "spam_tag2_level, " .
    	                 "spam_kill_level " .
    	          "FROM policy WHERE id = ?";
    	$sth = $dbh->query($select, array($policy_id));
    	if ($row = $sth->fetchRow()) {
    	    $default_quarantine_viruses = ($row["virus_lover"] == "N");
    	    $default_quarantine_spam = ($row["spam_lover"] == "N");
    	    $default_quarantine_banned_files = ($row["banned_files_lover"] == "N");
    	    $default_quarantine_bad_headers = ($row["bad_header_lover"] == "N");
    	    $default_virus_scanning = ($row["bypass_virus_checks"] == "N");
    	    $default_spam_filtering = ($row["bypass_spam_checks"] == "N");
    	    $default_banned_files_checking = ($row["bypass_banned_checks"] == "N");
    	    $default_bad_header_checking = ($row["bypass_header_checks"] == "N");
            $default_discard_viruses = ($row["discard_viruses"] == "Y");
  	    $default_discard_spam = ($row["discard_spam"] == "Y");
  	    $default_discard_banned_files = ($row["discard_banned_files"] == "Y");
  	    $default_discard_bad_headers = ($row["discard_bad_headers"] == "Y");
    	    $default_modify_subject = ($row["spam_modifies_subj"] == "Y");
    	    $default_score_level_1 = $row["spam_tag_level"];
    	    $default_score_level_2 = $row["spam_tag2_level"];
    	    $default_score_level_3 = $row["spam_kill_level"];
        }
        $sth->free();

        if (isset($_POST["viruses"])) {
            $viruses = trim($_POST["viruses"]);
        } else {
            $viruses = ($default_virus_scanning ? "yes" : "no");
        }
        if (isset($_POST["virus_destiny"])) {
            $virus_destiny = trim($_POST["virus_destiny"]);
        } else {
	    $virus_destiny = ($default_quarantine_viruses ? ($default_discard_viruses ? "discard" : "quarantine") : "label");
        }
        if (isset($_POST["spam"])) {
            $spam = trim($_POST["spam"]);
        } else {
            $spam = ($default_spam_filtering ? "yes" : "no");
        }
        if (isset($_POST["spam_destiny"])) {
            $spam_destiny = trim($_POST["spam_destiny"]);
        } else {
	    $spam_destiny = ($default_quarantine_spam ? ($default_discard_spam ? "discard" : "quarantine") : "label");
        }
        if (isset($_POST["banned"])) {
            $banned = trim($_POST["banned"]);
        } else {
            $banned = ($default_banned_files_checking ? "yes" : "no");
        }
        if (isset($_POST["banned_destiny"])) {
            $banned_destiny = trim($_POST["banned_destiny"]);
        } else {
	    $banned_destiny = ($default_quarantine_banned_files ? ($default_discard_banned_files ? "discard" : "quarantine") : "label");
        }
        if (isset($_POST["headers"])) {
            $headers = trim($_POST["headers"]);
        } else {
            $headers = ($default_bad_header_checking ? "yes" : "no");
        }
        if (isset($_POST["headers_destiny"])) {
            $headers_destiny = trim($_POST["headers_destiny"]);
        } else {
	    $headers_destiny = ($default_quarantine_bad_headers ? ($default_discard_bad_headers ? "discard" : "quarantine") : "label");
        }
        if (isset($_POST["modify_subject"])) {
            $modify_subject = trim($_POST["modify_subject"]);
        } else {
            $modify_subject = ($default_modify_subject ? "yes" : "no");
        }
        if (isset($_POST["level1"])) {
            $level1 = trim($_POST["level1"]);
        } else {
            $level1 = $default_score_level_1;
        }
        if (isset($_POST["level2"])) {
            $level2 = trim($_POST["level2"]);
        } else {
            $level2 = $default_score_level_2;
        }
        if (isset($_POST["level3"])) {
            $level3 = trim($_POST["level3"]);
        } else {
            $level3 = $default_score_level_3;
        }

        $bypass_virus_checks = ($viruses == "yes" ? "N" : "Y");
	$virus_lover = ($virus_destiny == "label" ? "Y" : "N");
  	$discard_viruses = ($virus_destiny == "discard" ? "Y" : "N");
        $bypass_spam_checks = ($spam == "yes" ? "N" : "Y");
	$spam_lover = ($spam_destiny == "label" ? "Y" : "N");
        $discard_spam = ($spam_destiny == "discard" ? "Y" : "N");
        $bypass_banned_checks = ($banned == "yes" ? "N" : "Y");
	$banned_files_lover = ($banned_destiny == "label" ? "Y" : "N");
        $discard_banned_files = ($banned_destiny == "discard" ? "Y" : "N");
        $bypass_header_checks = ($headers == "yes" ? "N" : "Y");
	$bad_header_lover = ($headers_destiny == "label" ? "Y" : "N");
  	$discard_bad_headers = ($headers_destiny == "discard" ? "Y" : "N");
        $spam_modifies_subj = ($modify_subject == "yes" ? "Y" : "N");
        $spam_tag_level = (double) $level1;
        $spam_tag2_level = (double) $level2;
        $spam_kill_level = (double) $level3;

        // Enforce tag_level <= tag2_level <= kill_level
        if ($spam_tag2_level > $spam_kill_level) {
            $spam_tag2_level = $spam_kill_level;
        }
        if ($spam_tag_level > $spam_tag2_level) {
            $spam_tag_level = $spam_tag2_level;
        }

        // Enforce spam kill level according to spam destiny
  	if ($spam_destiny == "label") {
  	    $spam_kill_level = 999;
  	} else {
  	    $spam_kill_level = $spam_tag2_level;
  	}

        // Update the policy table with the new settings.
        $update = "UPDATE policy SET virus_lover = ?, " .
                                    "spam_lover = ?, " .
                                    "banned_files_lover = ?, " .
                                    "bad_header_lover = ?, " .
                                    "bypass_virus_checks = ?, " .
                                    "bypass_spam_checks = ?, " .
                                    "bypass_banned_checks = ?, " .
                                    "bypass_header_checks = ?, " .
                                    "discard_viruses = ?, " .
  	                            "discard_spam = ?, " .
  	                            "discard_banned_files = ?, " .
  	                            "discard_bad_headers = ?, " .
                                    "spam_modifies_subj = ?, " .
                                    "spam_tag_level = ?, " .
                                    "spam_tag2_level = ?, " .
                                    "spam_kill_level = ? " .
                  "WHERE id = ?";

        if ($button == $lang['button_update_all_addresses']) {
            $select = "SELECT policy_id FROM users WHERE maia_user_id = ? ";
            $sth = $dbh->query($select, array($euid));
            while ($row = $sth->fetchrow()) {
                $dbh->query($update, array($virus_lover,
                                           $spam_lover,
                                           $banned_files_lover,
                                           $bad_header_lover,
                                           $bypass_virus_checks,
                                           $bypass_spam_checks,
                                           $bypass_banned_checks,
                                           $bypass_header_checks,
                                           $discard_viruses,
  	                                   $discard_spam,
  	                                   $discard_banned_files,
  	                                   $discard_bad_headers,
                                           $spam_modifies_subj,
                                           $spam_tag_level,
                                           $spam_tag2_level,
                                           $spam_kill_level,
                                           $row["policy_id"]));
            }
            $sth->free();
        } else {
            $dbh->query($update, array($virus_lover,
                                       $spam_lover,
                                       $banned_files_lover,
                                       $bad_header_lover,
                                       $bypass_virus_checks,
                                       $bypass_spam_checks,
                                       $bypass_banned_checks,
                                       $bypass_header_checks,
                                       $discard_viruses,
                                       $discard_spam,
                                       $discard_banned_files,
                                       $discard_bad_headers,
                                       $spam_modifies_subj,
                                       $spam_tag_level,
                                       $spam_tag2_level,
                                       $spam_kill_level,
                                       $policy_id));
        }

        $message = $lang['text_settings_updated'];

    // Pressed the "Update Miscellaneous Settings" button
    } elseif ($button == $lang['button_update_misc']) {

        if (isset($_POST["reminder"])) {
            $reminder = (trim($_POST["reminder"]) == "yes" ? "Y" : "N");
            if ($reminder_threshold_count > 0) {
                $update = "UPDATE maia_users SET reminders = ? WHERE id = ?";
                $dbh->query($update, array($reminder, $euid));
            }
        }
        if (isset($_POST["charts"])) {
            $charts = (trim($_POST["charts"]) == "yes" ? "Y" : "N");
            if ($enable_charts) {
                $update = "UPDATE maia_users SET charts = ? WHERE id = ?";
                $dbh->query($update, array($charts, $euid));
            }
        }
        if (isset($_POST["spamtrap"])) {
            $spamtrap = (trim($_POST["spamtrap"]) == "yes" ? "Y" : "N");
            if ($enable_spamtraps) {
                $update = "UPDATE maia_users SET spamtrap = ? WHERE id = ?";
                $dbh->query($update, array($spamtrap, $euid));
            }
        }
        if (isset($_POST["auto_whitelist"])) {
            $auto_whitelist = (trim($_POST["auto_whitelist"]) == "yes" ? "Y" : "N");
            $update = "UPDATE maia_users SET auto_whitelist = ? WHERE id = ?";
            $dbh->query($update, array($auto_whitelist, $euid));
        }
        if (isset($_POST["items_per_page"])) {
            $items_per_page = $_POST["items_per_page"];
            $update = "UPDATE maia_users SET items_per_page = ? WHERE id = ?";
            $dbh->query($update, array($items_per_page, $euid));
        }
        if (isset($_POST["digest_interval"])) {
            $quarantine_digest_interval = $_POST["digest_interval"];
            $update = "UPDATE maia_users SET quarantine_digest_interval = ? WHERE id = ?";
            $dbh->query($update, array($quarantine_digest_interval, $euid));
        }
        if (isset($_POST["language"])) {
            $language = trim($_POST["language"]);
            $update = "UPDATE maia_users SET language = ? WHERE id = ?";
            $dbh->query($update, array($language, $euid));
            $display_language = $language;
            $_SESSION["display_language"] = $display_language;
        }
        if (isset($_POST["charset"])) {
            $charset = trim($_POST["charset"]);
            $update = "UPDATE maia_users SET charset = ? WHERE id = ?";
            $dbh->query($update, array($charset, $euid));
            $html_charset = $charset;
            $_SESSION["html_charset"] = $html_charset;
        }
        if (isset($_POST["theme_id"])) {
            $theme_id = (trim($_POST["theme_id"]));
            $update = "UPDATE maia_users SET theme_id = ? WHERE id = ?";
            $dbh->query($update, array($theme_id, $euid));
        }
        if (isset($_POST["truncate_subject"])) {
            $truncate_subject = (trim($_POST["truncate_subject"]));
            $update = "UPDATE maia_users SET truncate_subject = ? WHERE id = ?";
            $dbh->query($update, array($truncate_subject, $euid));
        }
        if (isset($_POST["truncate_email"])) {
            $truncate_email = (trim($_POST["truncate_email"]));
            $update = "UPDATE maia_users SET truncate_email = ? WHERE id = ?";
            $dbh->query($update, array($truncate_email, $euid));
        }

        header("Location: settings.php");
		exit();


    // Pressed the "Add E-Mail Address" button
    } elseif ($button == $lang['button_add_email_address']) {

        if (isset($_POST["login"])) {
            $login = trim($_POST["login"]);
        } else {
            $login = "";
        }
        if (isset($_POST["authpass"])) {
            $password = trim($_POST["authpass"]);
            $password = stripslashes($password); // get rid of any escape characters
        } else {
            $password = "";
        }
        if (isset($_POST["domain"])) {
            $domain = trim($_POST["domain"]);
        } else {
            $domain = "";
        }

        if (($auth_method == "pop3" && !empty($routing_domain)) ||
            $auth_method == "ldap" || $auth_method == "exchange" ||
            $auth_method == "sql" || $auth_method == "internal" ||
            $auth_method == "external") {
            $user_name = $login;
            $address = "";
        } else {
            $address = $login;
            $user_name = "";
        }
        list($authenticated, $email) = auth($user_name, $password, $address, $domain);

        if ($authenticated === true) {
            $address_id = get_email_address_id($email);
            $old_owner = get_email_address_owner($address_id);
            if (!$old_owner) {
                add_email_address_to_user($euid, $email);
            } else {
                transfer_email_address_to_user($old_owner, $euid, $email);
            }
            $message = sprintf($lang['text_address_added'], $email);
        } else {
            $message = sprintf($lang['text_login_failed'], $login);
            if (PEAR::isError($authenticated)) {
              $message .= "<br>" . $authenticated->getMessage();
            }
        }

    // Pressed the "Update Login Credentials" button
    } elseif ($button == $lang['button_change_login_info'] && $auth_method == "internal") {

        if (isset($_POST["new_login_name"])) {
            $new_login = trim($_POST["new_login_name"]);
        } else {
            $new_login = "";
        }
        if (isset($_POST["new_password"])) {
            $new_password = trim(stripslashes($_POST["new_password"]));
        } else {
            $new_password = "";
        }
        if (isset($_POST["confirm_new_password"])) {
            $confirm_new_password = trim(stripslashes($_POST["confirm_new_password"]));
        } else {
            $confirm_new_password = "";
        }
        if (empty($new_login)) {
            $message = $lang['text_login_name_empty'];
        } elseif (empty($new_password) || empty($confirm_new_password)) {
            $message = $lang['text_password_empty'];
        }elseif ($new_password != $confirm_new_password) {
            $message = $lang['text_password_mismatch'];
        } else {
            $select = "SELECT id FROM maia_users WHERE user_name = ?";
            $sth = $dbh->query($select, array($new_login));
            if ($row = $sth->fetchrow()) {
                if ($row["id"] != $euid) {
                    $message = $lang['text_login_name_exists'];
                } else {
                    $update = "UPDATE maia_users SET password = ? WHERE id = ?";
                    $dbh->query($update, array(md5($new_password), $euid));
                    $message = $lang['text_password_updated'];
                }
            } else {
                if ($new_login[0] == "@") {
                    $message = $lang['text_login_name_not_allowed'];
                } else {
                    $update = "UPDATE maia_users SET user_name = ?, password = ? WHERE id = ?";
                    $dbh->query($update, array($new_login, md5($new_password), $euid));
                    $message = $lang['text_credentials_updated'];
                }
            }
            $sth->free();
        }

    } elseif (isset($_POST["user_id"])) {
    	$user_id = trim($_POST["user_id"]);
        $select = "SELECT users.id, users.email " .
                  "FROM users, maia_users " .
                  "WHERE users.maia_user_id = maia_users.id " .
                  "AND users.id <> maia_users.primary_email_id " .
                  "AND users.maia_user_id = ?";
        $sth = $dbh->query($select, array($user_id));
        while ($row = $sth->fetchrow()) {
            $email_id = $row["id"];
            $address = $row["email"];
            if (isset($_POST["make_primary_" . $email_id])) {
                $update = "UPDATE maia_users SET primary_email_id = ? WHERE id = ?";
                $dbh->query($update, array($email_id, $user_id));
                $message = sprintf($lang['text_new_primary_email'], $address);
            }
        }
        $sth->free();

	}
    require_once ("smarty.php");

    $smarty->assign("message", $message);
    
    //normal display stuff...
    
    $domain_user = is_a_domain_default_user($euid);
    $smarty->assign("euid", $euid);
    $smarty->assign('domain_user', $domain_user);
    $smarty->assign('domain_name', $domain_user ? get_user_name($euid)        : "");
    $smarty->assign('domain_id',   $domain_user ? get_domain_id($domain_user) : "");


    if (isset($_GET["addid"])) {
       $address_id = trim($_GET["addid"]);
       if (get_email_address_owner($address_id) != $euid) {
           $address_id = 0;
       }
    } else {
       $address_id = 0;
    }
    $smarty->assign('address_id', $address_id);
    
    if ($address_id === 0) {
        
        $smarty->assign('enable_charts', $enable_charts);
        $smarty->assign('reminder_threshold_count', $reminder_threshold_count);
        $smarty->assign('enable_spamtraps', $enable_spamtraps);
        $smarty->assign('enable_username_changes', $enable_username_changes);
        $smarty->assign('enable_address_linking', $enable_address_linking);

        $smarty->assign("auth_method", $auth_method);
        if (($auth_method == "pop3" && !empty($routing_domain)) ||
            $auth_method == "ldap" || $auth_method == "exchange" ||
            $auth_method == "sql" || $auth_method == "internal" || 
            $auth_method == "external") {
            $smarty->assign('login', $lang['text_username']);
        } else {
            $smarty->assign('login', $lang['text_email_address']);
        }

        $select = "SELECT users.id, users.email " .
                  "FROM users, maia_users " .
                  "WHERE users.maia_user_id = maia_users.id " .
                  "AND users.id = maia_users.primary_email_id " .
                  "AND users.email NOT LIKE '@%' " .
                  "AND users.maia_user_id = ?";
        $sth = $dbh->query($select, array($euid));
        if ($row = $sth->fetchrow()) {
            $smarty->assign('primary_email_id', $row["id"]);
            $primary_email_id = $row['id'];
            $smarty->assign('address', $row["email"]);
        }
        $sth->free();

       if (!$domain_user) {
           $select = "SELECT id, email FROM users WHERE maia_user_id = ? AND email NOT LIKE '@%' AND id <> ?";
           $sth = $dbh->query($select, array($euid, $primary_email_id));
           $user_addr = array();
           while ($row = $sth->fetchRow()) {
               $smarty->assign('atleastone', true);
               $user_addr[] = array(
                  'addid' =>  $row["id"],
                  'address' => $row["email"]
               );
           }
           $smarty->assign('user_addr', $user_addr);
           $sth->free();
       } else {
           $select = "SELECT id, email FROM users WHERE maia_user_id = ? AND email NOT LIKE '@%'";
           $sth = $dbh->query($select, array($euid));
           $user_addr = array();
           while ($row = $sth->fetchRow()) {
               $smarty->assign('atleastone', true);
               $user_addr[] = array(
                  'addid' =>  $row["id"],
                  'address' => $row["email"]
               );
           }
           $smarty->assign('user_addr', $user_addr);
           $sth->free();
       }
       if (!$domain_user && ($auth_method == "internal")) {
           $smarty->assign('user_name', get_user_name($euid));
       }
   
       $select = "SELECT id, name FROM maia_themes";
       $sth = $dbh->query($select);
       $themes = array();
       while ($row = $sth->fetchrow()) {
           $themes[$row['id']] = $row['name'];
       }
   
       $smarty->assign("themes", $themes);
   
        $select = "SELECT charts, reminders, language, charset, spamtrap, auto_whitelist, items_per_page, quarantine_digest_interval, theme_id, truncate_subject, truncate_email " .
                  "FROM maia_users WHERE maia_users.id = ?";
        $sth = $dbh->query($select, array($euid));
        if ($row = $sth->fetchRow()) {
            if ($row["charts"] == 'Y') {
                $smarty->assign('ch_y_checked', "checked");
                $smarty->assign('ch_n_checked', "");
            } else {
                $smarty->assign('ch_y_checked', "");
                $smarty->assign('ch_n_checked', "checked");
            }
            if ($row["reminders"] == 'Y') {
                $smarty->assign('rm_y_checked', "checked");
                $smarty->assign('rm_n_checked', "");
            } else {
                $smarty->assign('rm_y_checked', "");
                $smarty->assign('rm_n_checked', "checked");
            }
            if ($row["spamtrap"] == 'Y') {
                $smarty->assign('st_y_checked', "checked");
                $smarty->assign('st_n_checked', "");
            } else {
                $smarty->assign('st_y_checked', "");
                $smarty->assign('st_n_checked', "checked");
            }
            if ($row["auto_whitelist"] == 'Y') {
                $smarty->assign('wl_y_checked', "checked");
                $smarty->assign('wl_n_checked', "");
            } else {
                $smarty->assign('wl_y_checked', "");
                $smarty->assign('wl_n_checked', "checked");
            }
            $smarty->assign('language', $row["language"]);
            $smarty->assign('charset', $row["charset"]);
            $smarty->assign('items_per_page', $row["items_per_page"]);
            $smarty->assign('quarantine_digest_interval',
                            $row["quarantine_digest_interval"]);
            $smarty->assign('theme_id', $row["theme_id"]);
            $smarty->assign("truncate_subject", $row["truncate_subject"]);
            $smarty->assign("truncate_email", $row["truncate_email"]);
        }
        $sth->free();
        $smarty->assign('atleastone', false);
        
       $select = "SELECT language_name, abbreviation FROM maia_languages " .
                 "WHERE installed = 'Y' " .
                 "ORDER BY language_name ASC";
       $sth = $dbh->query($select);
       $data = array();
       $opt_lang = array();
       while ($row = $sth->fetchrow()) {
         $opt_lang[$row['abbreviation']] = $row['language_name'];
       }
       $smarty->assign('opt_lang', $opt_lang);
       $sth->free();
    } else {
	if (is_an_administrator($uid)) {
            $smarty->assign('user_virus_scanning', true);
            $smarty->assign('user_spam_filtering', true);
            $smarty->assign('user_banned_files_checking', true);
            $smarty->assign('user_bad_header_checking', true);
        } else {
            $select = "SELECT user_virus_scanning, " .
  	                     "user_spam_filtering, " .
  	                     "user_banned_files_checking, " .
  	                     "user_bad_header_checking " .
  	                     "FROM maia_config WHERE id = 0";
  	    $sth = $dbh->query($select);
  	 
  	    if ($row = $sth->fetchrow()) {
            	$smarty->assign('user_virus_scanning', ($row["user_virus_scanning"] == 'Y'));
            	$smarty->assign('user_spam_filtering', ($row["user_spam_filtering"] == 'Y'));
            	$smarty->assign('user_banned_files_checking', ($row["user_banned_files_checking"] == 'Y'));
            	$smarty->assign('user_bad_header_checking', ($row["user_bad_header_checking"] == 'Y'));
  	    }
  	    $sth->free();
  	}
        $select = "SELECT virus_lover, " .
                         "spam_lover, " .
                         "banned_files_lover, " .
                         "bad_header_lover, " .
                         "bypass_virus_checks, " .
                         "bypass_spam_checks, " .
                         "bypass_banned_checks, " .
                         "bypass_header_checks, " .
                         "discard_viruses, " .
                         "discard_spam, " .
                         "discard_banned_files, " .
                         "discard_bad_headers, " .
                         "spam_modifies_subj, " .
                         "spam_tag_level, " .
                         "spam_tag2_level, " .
                         "spam_kill_level, " .
                         "email, " .
                         "policy_id " .
                  "FROM users, policy " .
                  "WHERE users.policy_id = policy.id " .
                  "AND users.id = ?";

        $sth = $dbh->query($select, array($address_id));
        if ($row = $sth->fetchRow()) {
            $smarty->assign('address', $row["email"]);
            $smarty->assign('policy_id', $row["policy_id"]);
            $smarty->assign('level1', $row["spam_tag_level"]);
            $smarty->assign('level2', $row["spam_tag2_level"]);
            $smarty->assign('level3', $row["spam_kill_level"]);
            if ($row["virus_lover"] == 'Y') {
                $smarty->assign('v_l_checked', "checked");
                $smarty->assign('v_q_checked', "");
                $smarty->assign('v_d_checked', "");
            } else {
                $smarty->assign('v_l_checked', "");
		if ($row["discard_viruses"] == 'Y') {
                    $smarty->assign('v_q_checked', "");
                    $smarty->assign('v_d_checked', "checked");
		} else {
                    $smarty->assign('v_q_checked', "checked");
                    $smarty->assign('v_d_checked', "");
		}
            }
            if ($row["spam_lover"] == 'Y') {
                $smarty->assign('s_l_checked', "checked");
                $smarty->assign('s_q_checked', "");
                $smarty->assign('s_d_checked', "");
            } else {
                $smarty->assign('s_l_checked', "checked");
		if ($row["discard_spam"] == 'Y') {
                    $smarty->assign('s_q_checked', "");
                    $smarty->assign('s_d_checked', "checked");
		} else {
                    $smarty->assign('s_q_checked', "checked");
                    $smarty->assign('s_d_checked', "");
		}
            }
            if ($row["banned_files_lover"] == 'Y') {
                $smarty->assign('b_l_checked', "checked");
                $smarty->assign('b_q_checked', "");
                $smarty->assign('b_d_checked', "");
            } else {
                $smarty->assign('b_l_checked', "checked");
		if ($row["discard_banned_files"] == 'Y') {
                    $smarty->assign('b_q_checked', "");
                    $smarty->assign('b_d_checked', "checked");
		} else {
                    $smarty->assign('b_q_checked', "checked");
                    $smarty->assign('b_d_checked', "");
		}
            }
            if ($row["bad_header_lover"] == 'Y') {
                $smarty->assign('h_l_checked', "checked");
                $smarty->assign('h_q_checked', "");
                $smarty->assign('h_d_checked', "");
            } else {
                $smarty->assign('h_l_checked', "checked");
		if ($row["discard_bad_headers"] == 'Y') {
                    $smarty->assign('h_q_checked', "");
                    $smarty->assign('h_d_checked', "checked");
		} else {
                    $smarty->assign('h_q_checked', "checked");
                    $smarty->assign('h_d_checked', "");
		}
            }
            if ($row["bypass_virus_checks"] == 'Y') {
                $smarty->assign('bv_y_checked', "");
                $smarty->assign('bv_n_checked', "checked");
            } else {
                $smarty->assign('bv_y_checked', "checked");
                $smarty->assign('bv_n_checked', "");
            }
            if ($row["bypass_spam_checks"] == 'Y') {
                $smarty->assign('bs_y_checked', "");
                $smarty->assign('bs_n_checked', "checked");
            } else {
                $smarty->assign('bs_y_checked', "checked");
                $smarty->assign('bs_n_checked', "");
            }
            if ($row["bypass_banned_checks"] == 'Y') {
                $smarty->assign('bb_y_checked', "");
                $smarty->assign('bb_n_checked', "checked");
            } else {
                $smarty->assign('bb_y_checked', "checked");
                $smarty->assign('bb_n_checked', "");
            }
            if ($row["bypass_header_checks"] == 'Y') {
                $smarty->assign('bh_y_checked', "");
                $smarty->assign('bh_n_checked', "checked");
            } else {
                $smarty->assign('bh_y_checked', "checked");
                $smarty->assign('bh_n_checked', "");
            }
            if ($row["spam_modifies_subj"] == 'Y') {
                $smarty->assign('sms_y_checked', "checked");
                $smarty->assign('sms_n_checked', "");
            } else {
                $smarty->assign('sms_y_checked', "");
                $smarty->assign('sms_n_checked', "checked");
            }
        }
        $sth->free();
    }

    $smarty->assign('is_superadmin',is_superadmin($uid));
    $smarty->display('settings.tpl');
?>
